/* Prendre une douche ! */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <pthread.h>

// nombre de personnes
#define NB_PERSONNES 50

// nombre de cabines de douches
#define NB_CABINES 4

// etat pour la gestion d'une douche
#define ENTREE  1
#define SORTIE  2

// Les ressources pour gérer les douches
typedef struct
{
   int nb_filles;
   pthread_mutex_t filles_mutex;

   int nb_garcons;
   pthread_mutex_t garcons_mutex;

   int nb_cabines_libres;
   pthread_cond_t cabine_libre;
} RESSOURCES_DOUCHES;

// description d'une personne
typedef struct
{
   char prenom[16];
   char sexe;

   RESSOURCES_DOUCHES *res; // toutes les personnes partagent les memes ressources

   int heure_douche; // pour les calculs et statistiques
   int duree_douche;

   int duree_attente;
   int heure_fin_douche;
} PERSONNE;

// intialisation
RESSOURCES_DOUCHES *initialiserRessources(RESSOURCES_DOUCHES *res)
{
   /* TODO */

   return res;
}

/* section critique d'un garcon 
   Remarque : etat peut prendre soit la valeur ENTREE ou SORTIE */
void doucher_garcon(RESSOURCES_DOUCHES *res, int etat)
{
   /* TODO */
}


/* section critique d'une fille (symetrique par rapport aux garcons)
   Remarque : etat peut prendre soit la valeur ENTREE ou SORTIE */
void doucher_fille(RESSOURCES_DOUCHES *res, int etat)
{
   /* TODO */
}

/* threads de simulation */

// simulation d'un garcon
void *garcon(void *param)
{
   PERSONNE *p = (PERSONNE *)param;

   /* TODO */

   pthread_exit(NULL);
   return NULL;
}

// simulation d'une fille
void *fille(void *param)
{
   PERSONNE *p = (PERSONNE *)param;

   /* TODO */

   pthread_exit(NULL);
   return NULL;
}

int main(void)
{
   PERSONNE p[NB_PERSONNES];
   pthread_t tid[NB_PERSONNES];
   RESSOURCES_DOUCHES res;
   int nbg = 0, nbf = 0;
   int heure_debut, heure_fin;
   int rcode;
   int i;

   srand(time(NULL));

   initialiserRessources(&res);

   printf("Gymnase : %d cabines de douches pour %d personnes\n", NB_CABINES, NB_PERSONNES);

   heure_debut = time(NULL);

   // creation des filles et des garcons   
   for(i = 0; i < NB_PERSONNES; i++)
   {
      // attendre, tout le monde ne se presente pas en meme temps
      sleep(rand() % 2);

      if(rand() < RAND_MAX/2)
      {
         p[i].res  = &res; // toutes les personnes partagent les memes ressources
         p[i].sexe = 'G'; // je suis un garcon !
         sprintf(p[i].prenom, "ken%d", i);
         p[i].duree_douche = 3 + rand() % 5; // entre 3 et 7 secondes pour se doucher
         p[i].heure_douche = time(NULL); // heure d'arrive pour prendre la douche

         rcode = pthread_create(&tid[i], NULL, garcon, &p[i]);
         nbg++;
      }
      else
      {
         p[i].res  = &res; // toutes les personnes partagent les memes ressources
         p[i].sexe = 'F'; // je suis une fille !
         sprintf(p[i].prenom, "barbie%d", i);
         p[i].duree_douche = 3 + rand() % 5; // entre 3 et 7 secondes pour se doucher
         p[i].heure_douche = time(NULL); // heure d'arrive pour prendre la douche

         rcode = pthread_create(&tid[i], NULL, fille, &p[i]);
         nbf++;
      }
   }

   // attendre
   for(i = 0; i < NB_PERSONNES; i++)
      rcode = pthread_join(tid[i], NULL);

   heure_fin = time(NULL);


   /* affiche quelques statistiques */
   printf("Gymnase : %d cabines de douches pour %d personnes (%d garcons - %d filles)\n", NB_CABINES, NB_PERSONNES, nbg, nbf);
   printf("Duree totale : %d secondes\n", heure_fin - heure_debut);

   /* TODO */


   return 0;
}
